package com.lhy.test;


import java.security.KeyFactory;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.MessageDigest;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SecureRandom;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;
import java.util.HashMap;
import java.util.Map;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.Mac;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.codec.binary.Base64;

public class EncryptionUtil {
    public static String rsaPublicKey;
    private static String rsaPrivateKey;
    private static final String[] strDigits = new String[]{"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"};

    public EncryptionUtil() {
    }

    public void setRsaPublicKey(String rsaPublicKey) {
        EncryptionUtil.rsaPublicKey = rsaPublicKey;
    }

    public static void setRsaPrivateKey(String rsaPrivateKey) {
        EncryptionUtil.rsaPrivateKey = rsaPrivateKey;
    }

    public static String Base64encode(byte[] res) {
        return Base64.encodeBase64String(res);
    }

    public static byte[] Base64decode(byte[] ens) {
        return Base64.decodeBase64(ens);
    }

    private static String byteToArrayString(byte bByte) {
        int iRet = bByte;
        if (bByte < 0) {
            iRet = bByte + 256;
        }

        int iD1 = iRet / 16;
        int iD2 = iRet % 16;
        return strDigits[iD1] + strDigits[iD2];
    }

    public static String parseByte2HexStr(byte[] buf) {
        StringBuffer sb = new StringBuffer();

        for(int i = 0; i < buf.length; ++i) {
            String hex = Integer.toHexString(buf[i] & 255);
            if (hex.length() == 1) {
                hex = '0' + hex;
            }

            sb.append(hex.toUpperCase());
        }

        return sb.toString();
    }

    public static byte[] parseHexStr2Byte(String hexStr) {
        if (hexStr.length() < 1) {
            return null;
        } else {
            byte[] result = new byte[hexStr.length() / 2];

            for(int i = 0; i < hexStr.length() / 2; ++i) {
                int high = Integer.parseInt(hexStr.substring(i * 2, i * 2 + 1), 16);
                int low = Integer.parseInt(hexStr.substring(i * 2 + 1, i * 2 + 2), 16);
                result[i] = (byte)(high * 16 + low);
            }

            return result;
        }
    }

    public static String MD5(String res) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] resBytes = md.digest(res.getBytes());
            StringBuffer sBuffer = new StringBuffer();

            for(int i = 0; i < resBytes.length; ++i) {
                sBuffer.append(byteToArrayString(resBytes[i]));
            }

            return Base64encode(sBuffer.toString().getBytes());
        } catch (Exception var5) {
            var5.printStackTrace();
            return null;
        }
    }
    public static String MD5Code(String res,String code) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] resBytes = md.digest(res.getBytes(code));
            StringBuffer sBuffer = new StringBuffer();

            for(int i = 0; i < resBytes.length; ++i) {
                sBuffer.append(byteToArrayString(resBytes[i]));
            }

            return Base64encode(sBuffer.toString().getBytes());
        } catch (Exception var5) {
            var5.printStackTrace();
            return null;
        }
    }

    public static String MD5(String res, String key) {
        try {
            SecretKey sk = new SecretKeySpec(key.getBytes(), "HmacMD5");
            Mac mac = Mac.getInstance("HmacMD5");
            mac.init(sk);
            byte[] result = mac.doFinal(res.getBytes());
            StringBuffer sBuffer = new StringBuffer();

            for(int i = 0; i < result.length; ++i) {
                sBuffer.append(byteToArrayString(result[i]));
            }

            return Base64encode(sBuffer.toString().getBytes());
        } catch (Exception var7) {
            var7.printStackTrace();
            return null;
        }
    }

    public static String SHA1(String res) {
        try {
            MessageDigest md = MessageDigest.getInstance("SHA1");
            byte[] resBytes = res.getBytes();
            return Base64encode(md.digest(resBytes));
        } catch (Exception var3) {
            var3.printStackTrace();
            return null;
        }
    }

    public static String SHA1(String res, String key) {
        try {
            SecretKey sk = new SecretKeySpec(key.getBytes(), "HmacSHA1");
            Mac mac = Mac.getInstance("HmacSHA1");
            mac.init(sk);
            byte[] result = mac.doFinal(res.getBytes());
            return Base64encode(result);
        } catch (Exception var5) {
            var5.printStackTrace();
            return null;
        }
    }

    public static String DESencode(String res, String key) {
        try {
            KeyGenerator kg = KeyGenerator.getInstance("DES");
            kg.init(new SecureRandom(key.getBytes()));
            SecretKey sk = kg.generateKey();
            SecretKeySpec sks = new SecretKeySpec(sk.getEncoded(), "DES");
            Cipher cipher = Cipher.getInstance("DES");
            cipher.init(1, sks);
            return parseByte2HexStr(cipher.doFinal(res.getBytes()));
        } catch (Exception var6) {
            var6.printStackTrace();
            return null;
        }
    }

    public static String DESdecode(String res, String key) {
        try {
            KeyGenerator kg = KeyGenerator.getInstance("DES");
            kg.init(new SecureRandom(key.getBytes()));
            SecretKey sk = kg.generateKey();
            SecretKeySpec sks = new SecretKeySpec(sk.getEncoded(), "DES");
            Cipher cipher = Cipher.getInstance("DES");
            cipher.init(2, sks);
            return new String(cipher.doFinal(parseHexStr2Byte(res)));
        } catch (Exception var6) {
            var6.printStackTrace();
            return null;
        }
    }

    public static String AESencode(String res, String key) {
        try {
            KeyGenerator kg = KeyGenerator.getInstance("AES");
            kg.init(128, new SecureRandom(key.getBytes()));
            SecretKey sk = kg.generateKey();
            SecretKeySpec sks = new SecretKeySpec(sk.getEncoded(), "AES");
            Cipher cipher = Cipher.getInstance("AES");
            cipher.init(1, sks);
            return parseByte2HexStr(cipher.doFinal(res.getBytes()));
        } catch (Exception var6) {
            var6.printStackTrace();
            return null;
        }
    }

    public static String AESdecode(String res, String key) {
        try {
            KeyGenerator kg = KeyGenerator.getInstance("AES");
            kg.init(128, new SecureRandom(key.getBytes()));
            SecretKey sk = kg.generateKey();
            SecretKeySpec sks = new SecretKeySpec(sk.getEncoded(), "AES");
            Cipher cipher = Cipher.getInstance("AES");
            cipher.init(2, sks);
            return new String(cipher.doFinal(parseHexStr2Byte(res)));
        } catch (Exception var6) {
            var6.printStackTrace();
            return null;
        }
    }

    public static String XORencode(String res, String key) {
        byte[] bs = res.getBytes();

        for(int i = 0; i < bs.length; ++i) {
            bs[i] = (byte)(bs[i] ^ key.hashCode());
        }

        return parseByte2HexStr(bs);
    }

    public static String XORdecode(String res, String key) {
        byte[] bs = parseHexStr2Byte(res);

        for(int i = 0; i < bs.length; ++i) {
            bs[i] = (byte)(bs[i] ^ key.hashCode());
        }

        return new String(bs);
    }

    public static int XOR(int res, String key) {
        return res ^ key.hashCode();
    }

    public static String RSAencrypt(String plaintext, String... pubKey) {
        try {
            String publicKeyStr = rsaPublicKey;
            if (pubKey.length > 0) {
                publicKeyStr = pubKey[0];
            }

            byte[] keyBytes = Base64decode(publicKeyStr.getBytes());
            X509EncodedKeySpec keySpec = new X509EncodedKeySpec(keyBytes);
            KeyFactory keyFactory = KeyFactory.getInstance("RSA");
            PublicKey publicKey = keyFactory.generatePublic(keySpec);
            Cipher cipher = Cipher.getInstance("RSA");
            cipher.init(1, publicKey);
            return Base64encode(cipher.doFinal(plaintext.getBytes()));
        } catch (Exception var8) {
            var8.printStackTrace();
            return null;
        }
    }

    public static String RSAdecrypt(String ciphertext, String... priKey) {
        try {
            String privateKeyStr = rsaPrivateKey;
            if (priKey.length > 0) {
                privateKeyStr = priKey[0];
            }

            byte[] keyBytes = Base64decode(privateKeyStr.getBytes());
            PKCS8EncodedKeySpec keySpec = new PKCS8EncodedKeySpec(keyBytes);
            KeyFactory keyFactory = KeyFactory.getInstance("RSA");
            PrivateKey privateKey = keyFactory.generatePrivate(keySpec);
            Cipher cipher = Cipher.getInstance("RSA");
            cipher.init(2, privateKey);
            return new String(cipher.doFinal(Base64decode(ciphertext.getBytes())));
        } catch (Exception var8) {
            var8.printStackTrace();
            return null;
        }
    }

    public static Map<String, String> RSAgenerateKeyPair() {
        HashMap map = new HashMap();

        try {
            KeyPairGenerator keyPairGen = KeyPairGenerator.getInstance("RSA");
            keyPairGen.initialize(1024);
            KeyPair keyPair = keyPairGen.generateKeyPair();
            PublicKey publicKey = (RSAPublicKey)keyPair.getPublic();
            PrivateKey privateKey = (RSAPrivateKey)keyPair.getPrivate();
            map.put("PublicKey", Base64encode(publicKey.getEncoded()));
            map.put("PrivateKey", Base64encode(privateKey.getEncoded()));
        } catch (Exception var5) {
            var5.printStackTrace();
        }

        return map;
    }
}
