package com.lhy.test;


import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.apache.http.HttpResponse;
import org.apache.http.HttpVersion;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.util.EntityUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

public class TestApi {
    public static void main(String[] args) {
//    	Integer[] tests = new Integer[] {1,1,1,4,5,6,7,8,9,10};
//    	List<Integer> testList = Arrays.asList(tests);
//    	testList.parallelStream().forEach(tmp->{
//    	for(int i=0;i<100;i++){
    		requestApi();
//    	};
//    	requestApi();
    }
    
    
    public static void requestApi() {
    	String url = "https://data.gz.gov.cn/gzznapi46941836/data-source/data/view/table/46941836/list";
    	String app_key = "l6sf5k17";
    	String app_sercert = "d3rkAb17";
    	String service_api_id = "SYS_46941836";
    	String signature ="";
    	String timestamp = String.valueOf(System.currentTimeMillis()/1000);
    	Map<String, Object> paramMap = new HashMap<>();
    	Map<String, Object> bodyMap = new HashMap<>();
    	paramMap.put("body", bodyMap);
    	paramMap.put("page", 1);
    	paramMap.put("pageSize", 5);
    	paramMap.put("timestamp", timestamp);
    	
    	signature =  createSign(paramMap);
    	  //post请求返回结果
    	try (CloseableHttpClient  httpClient = HttpClientBuilder.create().build();){
	        JSONObject jsonResult = null;
	        HttpPost method = new HttpPost(url);
	        method.setHeader("app_key", app_key);
	        method.setHeader("app_sercert", app_sercert);
	        method.setHeader("service_api_id", service_api_id);
	        method.setHeader("timestamp", timestamp);
	        method.setHeader("signature", signature);
	        method.setHeader("app_key", app_key);
	        method.setHeader("Connection","Close");
	        method.setProtocolVersion(HttpVersion.HTTP_1_0);
	        paramMap.remove("timestamp");
	      
            if (null != paramMap) {
                //解决中文乱码问题
                StringEntity entity = new StringEntity(JSON.toJSONString(paramMap), "utf-8");
                entity.setContentEncoding("UTF-8");
                entity.setContentType("application/json");
                method.setEntity(entity);
            }
            long begin  = System.currentTimeMillis();
            
            HttpResponse result = httpClient.execute(method);
            
            long end  = System.currentTimeMillis();
            System.out.println("消耗："+(end-begin));
            url = URLDecoder.decode(url, "UTF-8");
            /**请求发送成功，并得到响应**/
            System.out.println("响应状态:"+result.getStatusLine().getStatusCode());
            if (result.getStatusLine().getStatusCode() == 200) {
                String str = "";
                try {
                    /**读取服务器返回过来的json字符串数据**/
                    str = EntityUtils.toString(result.getEntity());
                    /**把json字符串转换成json对象**/
                    jsonResult = JSONObject.parseObject(str);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }else {
                System.out.println("end:>>>>"+EntityUtils.toString(result.getEntity()));

            }
            System.out.println(jsonResult);
        } catch (Exception e) {
        	e.printStackTrace();
        }
    }
    
    
    public static String createSign(Map<String, Object> params) {
        Map<String, Object> sorted = new TreeMap<>();
        params.forEach( (k, v) -> {
                sorted.put(k, v);
        });
        StringBuilder builder = new StringBuilder();
        sorted.forEach((k, v) -> {
            builder.append(k).append("=").append(v).append("&");
        });
        String value = builder.toString();
        value = value.substring(0, value.length() - 1);
        String sign = EncryptionUtil.MD5(value);
//        System.out.println("sign:"+sign);
        return sign;
    }
}
